include \masm32\include\masm32rt.inc

IDC_REBAR1    equ 2
IDC_EDIT1     equ 3
IDC_EDIT2     equ 4
IDC_EDIT3     equ 5

CStr macro y:vararg
local sym,xxx
	.const
sym db y,0
	.code
	exitm <offset sym>
	endm

	.data

g_hInstance		HINSTANCE 0
g_hwndMain		HWND 0
g_hwndRebar1	HWND 0
g_hwndEdit1		HWND 0
g_hwndEdit2		HWND 0
g_hwndEdit3		HWND 0

	.code

OnSize proc uses ebx hWnd:HWND, wParam:WPARAM, lParam:LPARAM

LOCAL rect:RECT

	mov eax,wParam
	.if (eax == SIZE_RESTORED || eax == SIZE_MAXIMIZED)

		invoke GetClientRect, hWnd, addr rect

		invoke SetWindowPos, g_hwndRebar1, NULL, 0, 0,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit2, NULL, 0, 32,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

		invoke SetWindowPos, g_hwndEdit3, NULL, 0, 64,
			rect.right, 24, SWP_NOZORDER or SWP_NOACTIVATE

	.endif
	ret
	align 4

OnSize endp

;*** the main window proc

DlgProc proc hWnd:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM

	mov eax,uMsg
	.if (eax == WM_INITDIALOG)
		xor eax, eax
	.elseif (eax == WM_CLOSE)
		invoke DestroyWindow, hWnd
	.elseif (eax == WM_DESTROY)
		invoke PostQuitMessage,NULL
	.elseif (eax == WM_SIZE)
		invoke OnSize, hWnd, wParam, lParam
		mov eax, 1
	.elseif (eax == WM_COMMAND)
		.if ( wParam == IDCANCEL )
			invoke PostMessage, hWnd, WM_CLOSE, 0, 0
		.endif
		mov eax, 1
	.else
		xor eax, eax
	.endif
	ret
	align 4

DlgProc endp

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, lpszCmdLine:LPSTR, iCmdShow:dword

LOCAL ccsex:INITCOMMONCONTROLSEX
LOCAL msg:MSG
LOCAL rbbi:REBARBANDINFO

	mov ccsex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov ccsex.dwICC, ICC_BAR_CLASSES
	invoke InitCommonControlsEx, addr ccsex

;--- create modeless dialog

	invoke CreateDialogParam, hInst, 1, NULL, DlgProc, 0
	mov g_hwndMain, eax
	.if (!eax)
		invoke MessageBox, 0, CStr("CreateDialogParam failed"), 0, MB_OK
		ret
	.endif
	invoke GetDlgItem, g_hwndMain, IDC_REBAR1
	mov g_hwndRebar1, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDIT1
	mov g_hwndEdit1, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDIT2
	mov g_hwndEdit2, eax
	invoke GetDlgItem, g_hwndMain, IDC_EDIT3
	mov g_hwndEdit3, eax

;--- place first edit into rebar

	mov rbbi.cbSize,SIZEOF REBARBANDINFO
	mov rbbi.fMask,RBBIM_CHILD or RBBIM_SIZE or RBBIM_STYLE or RBBIM_CHILDSIZE or RBBIM_TEXT or RBBIM_ID
	mov rbbi.lpText, CStr("rebar1")
	mov eax, g_hwndEdit1
	mov rbbi.hwndChild,eax
	mov rbbi.fStyle, RBBS_GRIPPERALWAYS + RBBS_CHILDEDGE
;	mov rbbi.cx_,100
	mov rbbi.cxMinChild,100
	mov rbbi.cyChild,24
	mov rbbi.cyMinChild,24
	mov rbbi.wID,IDC_EDIT1
	invoke SendMessage,g_hwndRebar1, RB_INSERTBAND,-1,addr rbbi

	invoke ShowWindow, g_hwndMain, SW_NORMAL
	
	.while (1)
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if (eax == 0)
		invoke IsDialogMessage, g_hwndMain, ADDR msg
		.continue .if eax
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage,  ADDR msg
	.endw
exit:
	mov eax, msg.wParam
	ret
	align 4

WinMain endp


start proc public

	invoke GetModuleHandle, NULL
	mov g_hInstance, eax

	invoke WinMain, g_hInstance, 0, NULL, 0

	invoke ExitProcess,eax

start endp

	end start
Put resource section below end start; when pressing F6, content between the two Rsrc lines will be written to [filename].rc
Any kind of resources allowed here; use strings with e.g. Print Res$(101) or wPrint #1, wRes$(102) (w=wide, Unicode)
Do not use with OxPT_Icon - insert icon manually as shown below. You may delete these three lines now.
